"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function AccountSubAccountVCCSummaryTransactionMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.AccountSubAccountVCCSummaryTransactionMSSql = AccountSubAccountVCCSummaryTransactionMSSql;
function GetPlatformCancelledBatches(platformHash, installationId) {
    return new sql.Request(sqlConn)
        .input('PlatformHash', sql.VarChar(100), platformHash)
        .input('InstallationId', sql.VarChar(50), installationId)
        .execute('GetPlatformCancelledBatches')
        .then(function (recordsets) {
        logger.info('[AccountSubAccountVCCSummaryTransactionMSSql.mssql::GetPlatformCancelledBatches] Result: ', recordsets[0] ? recordsets[0].length : 0);
        var batchesResult = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve({ batches: batchesResult });
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetPlatformCancelledBatches = GetPlatformCancelledBatches;
function GetPlatformCurrentBatches(platformHash, installationId) {
    return new sql.Request(sqlConn)
        .input('PlatformHash', sql.VarChar(100), platformHash)
        .input('InstallationId', sql.VarChar(50), installationId)
        .execute('GetPlatformCurrentBatches')
        .then(function (recordsets) {
        logger.info('[AccountSubAccountVCCSummaryTransactionMSSql.mssql::GetPlatformCurrentBatches] Result: ', recordsets[1] ? recordsets[1].length : 0);
        var balanceResult = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var batchesResult = (recordsets && recordsets.length > 1 ? recordsets[1] : null);
        return Promise.resolve({ balance: balanceResult, batches: batchesResult });
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetPlatformCurrentBatches = GetPlatformCurrentBatches;
function CloseCancelledBatches(installationId) {
    return new sql.Request(sqlConn)
        .input('InstallationId', sql.VarChar(50), installationId)
        .execute('CloseCancelledBatches')
        .then(function (recordsets) {
        logger.info('[AccountSubAccountVCCSummaryTransactionMSSql.mssql::CloseCancelledBatches] Result: ', recordsets[1] ? recordsets[1].length : 0);
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.CloseCancelledBatches = CloseCancelledBatches;
function GetBatchBalanceDetail(platformHash, installationId, vcc, batchTypeName, batchTypeId) {
    return new sql.Request(sqlConn)
        .input('PlatformHash', sql.VarChar(100), platformHash)
        .input('InstallationId', sql.VarChar(50), installationId)
        .input('VCC', sql.VarChar(50), vcc)
        .input('BatchTypeName', sql.VarChar(50), batchTypeName)
        .input('BatchTypeId', sql.VarChar(50), batchTypeId)
        .execute('GetBatchBalanceDetail')
        .then(function (recordsets) {
        logger.info('[AccountSubAccountVCCSummaryTransactionMSSql.mssql::GetBatchBalanceDetail] Result: ', recordsets);
        var balancesResult = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(balancesResult);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetBatchBalanceDetail = GetBatchBalanceDetail;
function GetAccountSubAccountVCCBatchSummaryByBatchTypeId(platformHash, installationId, vcc, batchTypeName, batchTypeId) {
    return new sql.Request(sqlConn)
        .input('PlatformHash', sql.VarChar(100), platformHash)
        .input('InstallationId', sql.VarChar(50), installationId)
        .input('VCC', sql.VarChar(50), vcc)
        .input('BatchTypeName', sql.VarChar(50), batchTypeName)
        .input('BatchTypeId', sql.VarChar(100), batchTypeId)
        .execute('GetAccountSubAccountVCCBatchSummaryByBatchTypeId')
        .then(function (recordsets) {
        logger.info('[AccountSubAccountVCCSummaryTransactionMSSql.mssql::GetAccountSubAccountVCCBatchSummaryByBatchTypeId] Result: ', recordsets);
        var result = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(result);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAccountSubAccountVCCBatchSummaryByBatchTypeId = GetAccountSubAccountVCCBatchSummaryByBatchTypeId;
function GetAccountSubAccountVCCBatchSummaryId(platformHash, installationId, vcc, batchTypeName, batchTypeId) {
    return new sql.Request(sqlConn)
        .input('PlatformHash', sql.VarChar(100), platformHash)
        .input('InstallationId', sql.VarChar(50), installationId)
        .input('VCC', sql.VarChar(50), vcc)
        .input('BatchTypeName', sql.VarChar(50), batchTypeName)
        .input('BatchTypeId', sql.VarChar(100), batchTypeId)
        .execute('GetAccountSubAccountVCCBatchSummaryId')
        .then(function (recordsets) {
        logger.info('[AccountSubAccountVCCSummaryTransactionMSSql.mssql::GetAccountSubAccountVCCBatchSummaryId] Result: ', recordsets);
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var batch = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(batch);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAccountSubAccountVCCBatchSummaryId = GetAccountSubAccountVCCBatchSummaryId;
function AccountSubAccountVCCBatchSummaryCreate(platformHash, installationId, accountId, subAccountId, vcc, totalInteraction, totalAsync, totalAsyncDetail, estimatedNewTextPhrases, alreadyTextPhrases, rawChar, validChar, inProcessAsyncDetail, inProcessRawChar, alreadyTranscribedAsyncDetail, alreadyTranscribedRawChar, alreadyTranscribedValidChar, totalSync, totalAudio, estimatedNewCallPhrases, alreadyCallPhrases, durationTime, roundedDurationTime, inProcessAudio, inProcessDurationTime, alreadyTranscribedAudio, alreadyDurationTime, alreadyRoundedDurationTime, alreadyTranscribedDurationTime, alreadyTranscribedRoundedDurationTime, totalQueries, totalModels, modelRequests, batchTypeName, batchTypeId, processId, templateId, userApi, startDate) {
    logger.info('[AccountSubAccountVCCSummaryTransactionMSSql.mssql::AccountSubAccountVCCBatchSummaryCreate::] New batch => ', platformHash, installationId, accountId, subAccountId, vcc, totalInteraction, totalAsync, totalAsyncDetail, alreadyTextPhrases, rawChar, inProcessAsyncDetail, inProcessRawChar, alreadyTranscribedAsyncDetail, alreadyTranscribedRawChar, alreadyTranscribedValidChar, totalSync, totalAudio, alreadyCallPhrases, durationTime, roundedDurationTime, inProcessAudio, inProcessDurationTime, alreadyTranscribedAudio, alreadyDurationTime, alreadyRoundedDurationTime, alreadyTranscribedDurationTime, alreadyTranscribedRoundedDurationTime, totalQueries, totalModels, modelRequests, batchTypeName, batchTypeId, processId, templateId, userApi, startDate);
    return new sql.Request(sqlConn)
        .input('PlatformHash', sql.VarChar(100), platformHash)
        .input('InstallationId', sql.VarChar(50), installationId)
        .input('AccountId', sql.VarChar(50), accountId)
        .input('SubAccountId', sql.VarChar(50), subAccountId)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TotalInteraction', sql.Int, totalInteraction)
        .input('TotalAsync', sql.Int, totalAsync)
        .input('TotalAsyncDetail', sql.Int, totalAsyncDetail)
        .input('EstimatedNewTextPhrases', sql.Decimal(18, 5), estimatedNewTextPhrases)
        .input('AlreadyTextPhrases', sql.Int, alreadyTextPhrases)
        .input('RawChar', sql.Int, rawChar)
        .input('InProcessAsyncDetail', sql.Int, inProcessAsyncDetail)
        .input('InProcessRawChar', sql.Int, inProcessRawChar)
        .input('AlreadyTranscribedAsyncDetail', sql.Int, alreadyTranscribedAsyncDetail)
        .input('AlreadyTranscribedRawChar', sql.Int, alreadyTranscribedRawChar)
        .input('AlreadyTranscribedValidChar', sql.Int, alreadyTranscribedValidChar)
        .input('TotalSync', sql.Int, totalSync)
        .input('TotalAudio', sql.Int, totalAudio)
        .input('EstimatedNewCallPhrases', sql.Decimal(18, 5), estimatedNewCallPhrases)
        .input('AlreadyCallPhrases', sql.Int, alreadyCallPhrases)
        .input('DurationTime', sql.Int, durationTime)
        .input('RoundedDurationTime', sql.Int, roundedDurationTime)
        .input('InProcessAudio', sql.Int, inProcessAudio)
        .input('InProcessDurationTime', sql.Int, inProcessDurationTime)
        .input('AlreadyTranscribedAudio', sql.Int, alreadyTranscribedAudio)
        .input('AlreadyDurationTime', sql.Int, alreadyDurationTime)
        .input('AlreadyRoundedDurationTime', sql.Int, alreadyRoundedDurationTime)
        .input('AlreadyTranscribedDurationTime', sql.Int, alreadyTranscribedDurationTime)
        .input('AlreadyTranscribedRoundedDurationTime', sql.Int, alreadyTranscribedRoundedDurationTime)
        .input('TotalQueries', sql.Int, totalQueries)
        .input('TotalModels', sql.Decimal(18, 5), totalModels)
        .input('ModelRequests', sql.Decimal(18, 5), modelRequests)
        .input('BatchTypeName', sql.VarChar(50), batchTypeName)
        .input('BatchTypeId', sql.VarChar(100), batchTypeId)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('TemplateId', sql.VarChar(50), templateId)
        .input('UserApi', sql.VarChar(50), userApi)
        .input('StartDate', sql.DateTime, startDate)
        .execute('AccountSubAccountVCCBatchSummaryCreate')
        .then(function (recordsets) {
        logger.info('[AccountSubAccountVCCSummaryTransactionMSSql.mssql::AccountSubAccountVCCBatchSummaryCreate] Result: ', recordsets);
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.AccountSubAccountVCCBatchSummaryCreate = AccountSubAccountVCCBatchSummaryCreate;
function AccountSubAccountVCCBatchSummaryClose(batchId, closedDate) {
    return new sql.Request(sqlConn)
        .input('BatchId', sql.VarChar(50), batchId)
        .input('ClosedDate', sql.DateTime, closedDate)
        .execute('AccountSubAccountVCCBatchSummaryClose')
        .then(function (recordsets) {
        logger.info('[AccountSubAccountVCCSummaryTransactionMSSql.mssql::AccountSubAccountVCCBatchSummaryClose] Result: ', recordsets);
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.AccountSubAccountVCCBatchSummaryClose = AccountSubAccountVCCBatchSummaryClose;
function SaveAccountSubAccountVCCBatchSummaryTransactionStatus(platformHash, installationId, accountId, subAccountId, vcc, batchId, systemService, status, userApi) {
    return new sql.Request(sqlConn)
        .input('PlatformHash', sql.VarChar(100), platformHash)
        .input('InstallationId', sql.VarChar(50), installationId)
        .input('AccountId', sql.VarChar(50), accountId)
        .input('SubAccountId', sql.VarChar(50), subAccountId)
        .input('VCC', sql.VarChar(50), vcc)
        .input('BatchId', sql.VarChar(100), batchId)
        .input('SystemService', sql.VarChar(50), systemService)
        .input('Status', sql.VarChar(100), status)
        .input('UserApi', sql.VarChar(50), userApi)
        .execute('SaveAccountSubAccountVCCBatchSummaryTransactionStatus')
        .then(function (recordsets) {
        logger.info('[AccountSubAccountVCCSummaryTransactionMSSql.mssql::SaveAccountSubAccountVCCBatchSummaryTransactionStatus] Result: ', recordsets);
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveAccountSubAccountVCCBatchSummaryTransactionStatus = SaveAccountSubAccountVCCBatchSummaryTransactionStatus;
