"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function PlatformDataMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.PlatformDataMSSql = PlatformDataMSSql;
function SavePlatformData(platformHash, name, description, countryCode, clientName, clientContactName, clientContactEmail, inconcertContactName, commercialContactName, technicalContactName, transcriptionRatePerHour, transcriptionRatePerSecond, semanticAnalysisRatePerSecond, cognitiveAnalysisRatePerSecond, user) {
    return new sql.Request(sqlConn)
        .input('PlatformHash', sql.VarChar(100), platformHash)
        .input('Name', sql.VarChar(100), name)
        .input('Description', sql.VarChar(100), description)
        .input('CountryCode', sql.VarChar(10), countryCode)
        .input('ClientName', sql.VarChar(100), clientName)
        .input('ClientContactName', sql.VarChar(100), clientContactName)
        .input('ClientContactEmail', sql.VarChar(100), clientContactEmail)
        .input('InconcertContactName', sql.VarChar(100), inconcertContactName)
        .input('CommercialContactName', sql.VarChar(100), commercialContactName)
        .input('TechnicalContactName', sql.VarChar(100), technicalContactName)
        .input('TranscriptionRatePerHour', sql.Decimal(18, 5), transcriptionRatePerHour)
        .input('TranscriptionRatePerSecond', sql.Decimal(18, 5), transcriptionRatePerSecond)
        .input('SemanticAnalysisRatePerTransaction', sql.Decimal(18, 5), semanticAnalysisRatePerSecond)
        .input('CognitiveAnalysisRatePerTransaction', sql.Decimal(18, 5), cognitiveAnalysisRatePerSecond)
        .input('User', sql.VarChar(50), user)
        .execute('SavePlatformData')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SavePlatformData = SavePlatformData;
function SavePlatformBuildVersion(platformHash, installationId, buildVersion) {
    return new sql.Request(sqlConn)
        .input('PlatformHash', sql.VarChar(100), platformHash)
        .input('InstallationId', sql.VarChar(100), installationId)
        .input('BuildVersion', sql.VarChar(25), buildVersion)
        .execute('SavePlatformBuildVersion')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SavePlatformBuildVersion = SavePlatformBuildVersion;
