"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function ReportMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.ReportMSSql = ReportMSSql;
function GetReports(search_criteria, search_expression) {
    return new sql.Request(sqlConn)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .execute('GetReports')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetReports = GetReports;
function GetReport(id) {
    return new sql.Request(sqlConn)
        .input('ID', sql.VarChar(50), id)
        .execute('GetReport')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var report = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(report);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetReport = GetReport;
function ReportByVccBalanceSummaryExec(installationId, endDate, batchTypeName, batchTypeId, userApi, vcc) {
    return new sql.Request(sqlConn)
        .input('InstallationId', sql.VarChar(100), installationId)
        .input('EndDate', sql.DateTime, endDate)
        .input('BatchTypeName', sql.VarChar(50), batchTypeName)
        .input('BatchTypeId', sql.VarChar(50), batchTypeId)
        .input('UserApi', sql.VarChar(50), userApi)
        .input('VCC', sql.VarChar(50), vcc)
        .execute('ReportByVccBalanceSummary')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.ReportByVccBalanceSummaryExec = ReportByVccBalanceSummaryExec;
function GetReportProcedureParameters(procedure) {
    return new sql.Request(sqlConn)
        .input('Procedure', sql.VarChar(50), procedure)
        .execute('GetReportProcedureParameters')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetReportProcedureParameters = GetReportProcedureParameters;
function ExecuteReportProcedure(procedure, parameters) {
    var request = new sql.Request(sqlConn);
    parameters.forEach(function (item, index) {
        request.input(item.column, item.value);
    });
    return request.execute(procedure)
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.ExecuteReportProcedure = ExecuteReportProcedure;
