"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var log4js = require("log4js");
var logger = log4js.getLogger('ServerScripts');
var account_service_1 = require("./account.service");
var activation_service_1 = require("./activation.service");
var auth_service_1 = require("./auth.service");
var api_user_service_1 = require("./api-user.service");
var batch_service_1 = require("./batch.service");
var country_service_1 = require("./country.service");
var currency_service_1 = require("./currency.service");
var platform_service_1 = require("./platform.service");
var vcc_service_1 = require("./vcc.service");
var client_service_1 = require("./client.service");
var report_service_1 = require("./report.service");
function init(app) {
    logger.info('Incializando servicios');
    account_service_1.AccountService(app);
    activation_service_1.ActivationService(app);
    api_user_service_1.ApiUserService(app);
    auth_service_1.AuthService(app);
    batch_service_1.BatchService(app);
    country_service_1.CountryService(app);
    currency_service_1.CurrencyService(app);
    platform_service_1.PlatformService(app);
    vcc_service_1.VCCService(app);
    client_service_1.ClientService(app);
    report_service_1.ReportService(app);
}
exports.init = init;
